<HTML>
<HEAD>
<TITLE>Eintr&auml;ge im G&auml;stebuch</TITLE>
</HEAD>
<BODY BGCOLOR="#ffffff">

<H1>Eintr&auml;ge im G&auml;stebuch</H1>
<%
strConnection = "Driver={Microsoft Access Driver (*.mdb)};DBQ="
strConnection = strConnection & Server.MapPath("guestbook2000.mdb") 
strConnection = strConnection & ";DriverId=25;FIL=MS Access;MaxBufferSize=512;PageTimeout=5;"

' korrekt nach Datum absteigend sortiert; first ten records
Const cstrFirstTenRecords = "SELECT TOP 10 IdField,Name,EmailAddress,Homepage,Browser,OperatingSystem,EntryDate,Comment from Guestbook ORDER BY IdField DESC"
' next ten records
Const cstrNextTenRecP1 = "SELECT TOP 10 IdField,Name,EmailAddress,Homepage,Browser,OperatingSystem,EntryDate,Comment from Guestbook WHERE IdField < "
Const cstrNextRecP2 = " ORDER BY IdField DESC"
' previous ten records; WRONG SORT ORDER INITIALLY!
Const cstrPrevTenRecP1 = "SELECT TOP 10 IdField,Name,EmailAddress,Homepage,Browser,OperatingSystem,EntryDate,Comment from Guestbook WHERE IdField > "
Const cstrPrevRecP2 = " ORDER BY IdField ASC"

strPageDirection = Trim(Request.QueryString("Page"))
If "" = strPageDirection Then strPageDirection = "Start"
nLastIndex = Trim(Request.QueryString("Index"))
If ("" = nLastIndex Or Not IsNumeric(nLastIndex)) Then strPageDirection = "Start"

Select Case strPageDirection
	Case "Next"
		strSQL = cstrNextTenRecP1 & nLastIndex & cstrNextRecP2
	Case "Prev"
		strSQL = cstrPrevTenRecP1 & nLastIndex & cstrPrevRecP2
		bTopDown = True
	Case Else
		strSQL = cstrFirstTenRecords
End Select

Set conn = CreateObject("ADODB.Connection")
conn.Open strConnection
Set rs = CreateObject ("ADODB.Recordset")
rs.Open strSQL, conn

If Not rs.EOF and Not rs.BOF Then
	avarRecords = rs.GetRows()
Else
	bNoRecords = True
End If 

rs.Close

' get summary information
rs.Open "SELECT * FROM qSummaries", conn
nTotalRecords = rs(0)
If nTotalRecords <> 0 Then
	rs.MoveNext
	nTotalMax = rs(0)
	rs.MoveNext
	nTotalMin = rs(0)
End If
rs.Close

conn.Close
Set rs = Nothing
Set conn = Nothing

strScriptName = Request.ServerVariables("SCRIPT_NAME")
If Not bNoRecords Then
	nRecords = UBound(avarRecords,2)
	If Not bTopDown Then
		nPrevPaging = avarRecords(0,0)
		nLastPaging = avarRecords(0,nRecords)
	Else
		nPrevPaging = avarRecords(0,nRecords)
		nLastPaging = avarRecords(0,0)
	End If

	Response.Write "<TABLE WIDTH=""500"">"
	Response.Write "<TR><TD COLSPAN=""2"" bgcolor=""#003399""><font color=""white""><b>Anzahl Eintr&auml;ge: " & nTotalRecords 
	Response.Write "</b></font></td></tr>" & vbCrLf
	WritePagingHeaders
	
	If Not bTopDown Then
		For intRecord = 0 To nRecords
			WriteRecord avarRecords, intRecord
		Next
	Else
		For intRecord = nRecords To 0 Step -1
			WriteRecord avarRecords, intRecord
		Next
	End If
	WritePagingHeaders
	Response.Write "</TABLE>"
Else
	Response.Write "<p>Keine Eintragungen gefunden!</p>"
End If	' bNoRecords

Sub WriteRecord(avarRecords, intRecord)
	Response.Write "<TR><TD valign=""top"">"
	Response.Write "<b>Name:</b>&nbsp;" & avarRecords(1,intRecord) & "<br>"
	Response.Write "<b>eMail:</b>&nbsp;"
	If "" <> avarRecords(2,intRecord) Then
		Response.Write "<a href=""mailto:" & avarRecords(2,intRecord) & """>"
		Response.Write avarRecords(2,intRecord) & "</a>"
	Else
		Response.Write "keine"
	End If
	Response.Write "<br>"
	Response.Write "<b>Homepage:</b>&nbsp;" 
	If "" <> avarRecords(3,intRecord) Then
		Response.Write "<a href=""http://" & avarRecords(3,intRecord) & """ target=""_new"">"
		Response.Write "http://" & avarRecords(3,intRecord) & "</a>"
	Else
		Response.Write "keine"
	End If
	Response.Write "<br>"
	Response.Write "<b>Kommentar:</b>&nbsp;" & Replace(avarRecords(7,intRecord),vbCrlf,"<br>") & "<br>"
	Response.Write "</TD><TD valign=""top"" align=""right"">"
	Response.Write avarRecords(5,intRecord) & " / " & avarRecords(4,intRecord)
	Response.Write "<br><b>" & avarRecords(6,intRecord) & "</b>"
	Response.Write "</td></tr>" & vbCrLf
	Response.Write "<tr><td colspan=2><hr></td></tr>" & vbCrlf
End Sub

Sub WritePagingHeaders()
%>
	<TR><TD colspan="2" bgcolor="#FFFFCC">
      <table border="0" cellspacing="1">
        <tr>
          <td>
		  <%
		  	If nTotalMax > nPrevPaging Then
				Response.Write "<a href=""" & strScriptName & "?Page=Prev&Index=" & nPrevPaging 
				Response.Write """>10 zur&uuml;ck</a>"
			Else
				Response.Write "10 zur&uuml;ck"
			End If
		  %>
		  </td>
          <td><b>|</b></td>
          <td><a href="<%=strScriptName & "?Page=Start"%>">anfang</a></td>
          <td><b>|</b></td>
          <td>
		   <%
		  	If nTotalMin < nLastPaging Then
				Response.Write "<a href=""" & strScriptName & "?Page=Next&Index=" & nLastPaging 
				Response.Write """>n&auml;chsten 10</a>"
			Else
				Response.Write "n&auml;chsten 10"
			End If
		  %>
		  </td>
        </tr>
      </table>
	</td></tr>
<%
End Sub
%>

</BODY>
</HTML>
